#include "stdafx.h"
#include "NeMessenger.h"
#include "NMessageBox.h"
#include "DuiDefine.h"
#include "NeMessengerDlg.h"
#include "..\..\DuiLib\Utils\WinImplBase.h"


#define  MAX_MESSAGEBOX_COUNT 10

int g_ModalBoxCount = 0;
int g_nMessageBoxCount = 0;
HWND g_hMessageBox[MAX_MESSAGEBOX_COUNT] = {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
CCriticalSection g_csModalBoxCount;


int NMessageBox(CWnd *pParent, LPCTSTR pszText, LPCTSTR pszCaption /* = _T("Ntalk biz") */, 
                UINT nType /* = MB_OK */, BOOL bShowCheck /* = FALSE */, LPCTSTR pszCheckMsg /* = _T("") */, 
                LPCTSTR pszCheckID /* = _T("") */,  BOOL bForeceTopWindow /*= FALSE*/, LPCTSTR pszYes /* = _T("") */, LPCTSTR pszNo /* = _T("") */)
{
    if (g_nMessageBoxCount >= MAX_MESSAGEBOX_COUNT - 1)
    {
        return 0;
    }

    CDuiMessageBox dlg(pParent);

    //ĸǸ AX  Ұ Ͽ ĸǸ 
    dlg.Init(pszText, L"Ntalk MessageBox", nType, bShowCheck, pszCheckMsg, pszCheckID, bForeceTopWindow, pszYes, pszNo);
    CSingleLock modalBoxCountLock(&g_csModalBoxCount);
    modalBoxCountLock.Lock();
    ++g_ModalBoxCount;
    modalBoxCountLock.Unlock();

    GET_MESSENGER_DLG()->RegisterDuiModalWnd(&dlg);
    int result = dlg.ShowModal();
    GET_MESSENGER_DLG()->UnRegisterDuiModalWnd(&dlg);

    modalBoxCountLock.Lock();
    --g_ModalBoxCount;
    modalBoxCountLock.Unlock();

    return result;
}

int NMessageBoxEx(HWND hwndParentWindow, LPCTSTR pszText, LPCTSTR pszCaption /* = _T("Ntalk biz") */, 
                  UINT nType /* = MB_OK */, BOOL bShowCheck /* = FALSE */, LPCTSTR pszCheckMsg /* = _T("") */, 
                  LPCTSTR pszCheckID /* = _T("") */, BOOL bForeceTopWindow /* = FALSE */, 
                  LPCTSTR pszYes /* = _T("") */ , LPCTSTR pszNo /* = _T("") */ )
{
    if (g_nMessageBoxCount >= MAX_MESSAGEBOX_COUNT - 1)
    {
        return 0;
    }

    CDuiMessageBox dlg(hwndParentWindow);
    dlg.Init(pszText, L"Ntalk MessageBox", nType, bShowCheck, pszCheckMsg, pszCheckID, bForeceTopWindow, pszYes, pszNo);
    CSingleLock modalBoxCountLock(&g_csModalBoxCount);
    modalBoxCountLock.Lock();
    ++g_ModalBoxCount;
    modalBoxCountLock.Unlock();

    GET_MESSENGER_DLG()->RegisterDuiModalWnd(&dlg);
    int result = dlg.ShowModal();
    GET_MESSENGER_DLG()->UnRegisterDuiModalWnd(&dlg);

    modalBoxCountLock.Lock();
    --g_ModalBoxCount;
    modalBoxCountLock.Unlock();

    return result;
}


DUI_BEGIN_MESSAGE_MAP(CDuiMessageBox, WindowImplBase, FALSE)
	DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
	DUI_ON_MSGTYPE(DUI_MSGTYPE_CLICK, NotifyCtrlClick)     //kClick
	DUI_ON_MSGTYPE(DUI_MSGTYPE_SETFOCUS, OnNotifySetFocus)
	DUI_ON_MSGTYPE(DUI_MSGTYPE_KILLFOCUS, OnNotifyKillFocus)
DUI_END_MESSAGE_MAP()


CDuiMessageBox::CDuiMessageBox(CWnd* pParent)
{
	CreateMessageBox(pParent->GetSafeHwnd());
}

CDuiMessageBox::CDuiMessageBox(HWND hParentWnd)
{
	CreateMessageBox(hParentWnd);
}

CDuiMessageBox::~CDuiMessageBox()
{

}

void CDuiMessageBox::CreateMessageBox(HWND hParentWnd)
{
    m_bShowCheck = FALSE;
    m_bForceWindowTop = FALSE;
	m_bClosing = FALSE;
	m_uType = MB_OK;

	Create(hParentWnd, _T("NMessage Box"), WS_POPUPWINDOW, WS_EX_DLGMODALFRAME, CRect(0,0,270,156));
	::ShowWindow(m_hWnd, SW_HIDE);
}

void CDuiMessageBox::Init(LPCTSTR pszText, LPCTSTR pszCaption, UINT uType, BOOL bShowCheck, LPCTSTR pszCheckMsg, LPCTSTR pszCheckID, BOOL bForceWindowTop,
						LPCTSTR pszYes, LPCTSTR pszNo)
{
	m_strText = pszText;
	m_strCaption = pszCaption;
	m_uType = uType;

	m_bShowCheck = bShowCheck;
	m_strCheckMsg = pszCheckMsg;
	m_strCheckID = pszCheckID;

	m_bForceWindowTop = bForceWindowTop;

	m_strYes = pszYes;
	m_strNo = pszNo;
}


LPCTSTR CDuiMessageBox::GetWindowClassName() const
{
	return _T("MessageBox");
}

void CDuiMessageBox::OnFinalMessage(HWND hWnd)
{
	WindowImplBase::OnFinalMessage(hWnd);
}

void CDuiMessageBox::NotifyCtrlClick(TNotifyUI& msg)
{
	if (_tcsicmp(msg.pSender->GetName(), kCloseButtonControlName) == 0)
	{
		Close(IDCANCEL);
	}
	else if (_tcsicmp(msg.pSender->GetName(), kMessageBoxYes) == 0)
	{
		ClickButton(0);
	}
	else if (_tcsicmp(msg.pSender->GetName(), kMessageBoxNo) == 0)
	{
		ClickButton(1);
	}
}

void CDuiMessageBox::ClickButton(int nButtonIndex)
{
	switch (m_uType)
	{
	case MB_OK:
		{
			Close(IDOK);
			break;
		}
	case MB_OKCANCEL:
	case MB_SAVECLOSE:
		{
			if (nButtonIndex == 0)
			{
				Close(IDOK);
			}
			else
			{
				Close(IDCANCEL);
			}
			break;
		}
	case MB_YESNO:
		{
			if (nButtonIndex == 0)
			{
				Close(IDYES);
			}
			else
			{
				Close(IDNO);
			}
			break;
		}
	default:
		{
			Close(IDOK);
			break;
		}
	}
}

void CDuiMessageBox::SetButtonText()
{
	CButtonUI* pBtnYes =  static_cast<CButtonUI*>(m_PaintManager.FindControl(kMessageBoxYes));
	CButtonUI* pBtnNo =  static_cast<CButtonUI*>(m_PaintManager.FindControl(kMessageBoxNo));
	if (pBtnYes == NULL || pBtnNo == NULL)
	{
		return;
	}
	switch (m_uType)
	{
	case MB_OK:
		{
			pBtnYes->SetText(LoadStringFromResource(IDS_STRING568));
			pBtnYes->SetFixedWidth(268);
			pBtnNo->SetVisible(false);
			break;
		}
	case MB_OKCANCEL:
		{
			pBtnYes->SetText(LoadStringFromResource(IDS_STRING568));
			pBtnNo->SetText(LoadStringFromResource(IDS_STRING569));
			break;
		}
	case MB_SAVECLOSE:
		{
			pBtnYes->SetText(LoadStringFromResource(IDS_STRING474));
			pBtnNo->SetText(LoadStringFromResource(IDS_STRING565));
			break;
		}
	case MB_YESNO:
		{
			if (m_strYes.GetLength() == 0)
			{
				pBtnYes->SetText(LoadStringFromResource(IDS_STRING399));
			}
			else
			{
				pBtnYes->SetText(m_strYes);
			}
			if (m_strNo.GetLength() == 0)
			{
				pBtnNo->SetText(LoadStringFromResource(IDS_STRING400));
			}
			else
			{
				pBtnNo->SetText(m_strNo);
			}
			break;
		}
	default:
		{
			pBtnYes->SetText(LoadStringFromResource(IDS_STRING568));
			pBtnYes->SetFixedWidth(268);
			pBtnNo->SetVisible(false);
			break;
		}
	}
}

void CDuiMessageBox::OnNotifySetFocus(TNotifyUI& msg)
{
	
}

void CDuiMessageBox::OnNotifyKillFocus(TNotifyUI& msg)
{

}

void CDuiMessageBox::OnPrepare(TNotifyUI& msg)
{
	CRichEditUI* pText =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(kMessageBoxText));
	if (pText != NULL)
	{
		pText->SetText(m_strText);
		//SIZE szTextCtrl = {250, 1000};
		//SIZE szText = pText->EstimateSize(szTextCtrl);
		int nTextHeight = pText->GetLineCount() * 16;
		int nHeightWnd = 36 + 28 + nTextHeight + 28 + 35;
		MoveWindow(m_hWnd, 0, 0, 270, nHeightWnd, FALSE);
		pText->SetFixedHeight(nTextHeight + 28);
		CenterWindow();
		::ShowWindow(m_hWnd, SW_SHOW);
	}
	SetButtonText();
}

CDuiString CDuiMessageBox::GetSkinFile()
{
	return _T("NMessageBox.xml");
}

CDuiString CDuiMessageBox::GetSkinFolder()
{
	return _T("skin\\nTalkRes");
}

LRESULT CDuiMessageBox::OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return 0;
}

LRESULT CDuiMessageBox::OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	POINT pt = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };
	CRichEditUI* pText =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(kMessageBoxText));
	if (pText != NULL)
	{
		CRect rcText = pText->GetPos();
		if (rcText.PtInRect(pt))
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
		}
	}
	bHandled = FALSE;
	return 0;
}

LRESULT CDuiMessageBox::OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	POINT pt = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };
	CRichEditUI* pText =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(kMessageBoxText));
	if (pText != NULL)
	{
		CRect rcText = pText->GetPos();
		if (rcText.PtInRect(pt))
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
			SetFocus(NULL);
			bHandled = TRUE;
			return 0;
		}
	}
	CButtonUI* pBtnClose =  static_cast<CButtonUI*>(m_PaintManager.FindControl(kCloseButtonControlName));
	CHorizontalLayoutUI* pTitle =  static_cast<CHorizontalLayoutUI*>(m_PaintManager.FindControl(kPopupTitle));
	if (pBtnClose != NULL && pTitle != NULL)
	{
		CRect rcText = pBtnClose->GetPos();
		if (rcText.PtInRect(pt))
		{
			CString strImage = GetAppDUIImgDir() + _T("\\img_alarm_popup_bg_top_off.png");
			pTitle->SetBkImage(strImage);
		}
	}
	bHandled = FALSE;
	return 0;
}

LRESULT CDuiMessageBox::OnLButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	POINT pt = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };
	CRichEditUI* pText =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(kMessageBoxText));
	if (pText != NULL)
	{
		CRect rcText = pText->GetPos();
		if (rcText.PtInRect(pt))
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
			SetFocus(NULL);
			bHandled = TRUE;
			return 0;
		}
	}
	CHorizontalLayoutUI* pTitle =  static_cast<CHorizontalLayoutUI*>(m_PaintManager.FindControl(kPopupTitle));
	if (pTitle != NULL)
	{
		CString strImage = GetAppDUIImgDir() + _T("\\img_alarm_popup_bg_top_on.png");
		pTitle->SetBkImage(strImage);
	}
	bHandled = FALSE;
	return 0;
}

LRESULT CDuiMessageBox::OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	int ret = __super::OnNcHitTest(uMsg, wParam, lParam, bHandled);
	if (ret != HTCAPTION)
	{
		ret = HTCLIENT;
	}
	return ret;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
